﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4.28
@EndOfDesignText@
#Event: ItemClick (Index As Int, Value As Object)
#Event: ItemLongClick (Index As Int, Value As Object)
#Event: ReachEnd
#DesignerProperty: Key: DividerColor, DisplayName: Divider Color, FieldType: Color, DefaultValue: 0xFFA9A9A9
#DesignerProperty: Key: DividerHeight, DisplayName: Divider Height, FieldType: Int, DefaultValue: 2
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFF000000
#DesignerProperty: Key: TextBackgroundColor, DisplayName: Text Background Color, FieldType: Color, DefaultValue: 0xFFFFFFFF
#DesignerProperty: Key: InsertAnimationDuration, DisplayName: Insert Animation Duration, FieldType: Int, DefaultValue: 300

Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As WeakRef
	Public sv As ScrollView
	
	Private items As List
	Private panels As List
	Private heights As List
	Private dividerHeight As Float
	Private EventName As String
	Private CallBack As Object
	Public DefaultTextFont As Font
	Public DefaultTextColor As Int
	Public DefaultTextBackgroundColor As Int
	Private HighlightColor As Int = Colors.White
	Public AnimationDuration As Int = 300
	Private LastReachEndEvent As Long
	
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	items.Initialize
	panels.Initialize
	heights.Initialize
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase.Value = Base
	sv.Initialize("sv", Base.Width, 0)
	sv.Bounces = False
	Base.AddView(sv, 0, 0, Base.Width, Base.Height)
	dividerHeight = Props.Get("DividerHeight")
	DefaultTextColor = Props.Get("TextColor")
	DefaultTextBackgroundColor = Props.Get("TextBackgroundColor")
	AnimationDuration = Props.GetDefault("InsertAnimationDuration", AnimationDuration)
	Base.Color = Props.Get("DividerColor")
	DefaultTextFont = Lbl.Font
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	If Width <> sv.ContentWidth Then
		sv.ContentWidth = Width
		For Each p As Panel In panels
			p.width = Width
			p.GetView(0).width = Width
		Next
	End If
	Dim c As Int = sv.ScrollOffsetY
	sv.SetLayoutAnimated(0, 0, sv.Left, sv.Top, Width, Height)
	SetOffset(c)
End Sub

Public Sub GetBase As Panel 
	Return mBase.Value
End Sub

'Clears all items.
Public Sub Clear
	items.Clear
	panels.Clear
	heights.Clear
	sv.ContentHeight = 0
	sv.Panel.RemoveAllViews
End Sub

'Returns the number of items.
Public Sub GetSize As Int
	Return items.Size
End Sub

'Returns the Panel stored at the specified index.
Public Sub GetPanel(Index As Int) As Panel
	Dim p As Panel
	p = panels.Get(Index) 'this is the parent panel
	Return p.GetView(0)
End Sub

'Returns the value stored at the specified index.
Public Sub GetValue(Index As Int) As Object
	Return items.Get(Index)
End Sub

'Removes the item at the specified index.
Public Sub RemoveAt(Index As Int)
	Dim removePanel, p As Panel
	removePanel = panels.Get(Index)
	For i = Index + 1 To items.Size - 1
		p = panels.Get(i)
		p.Tag = i - 1
		Dim NewTop As Int = p.Top - heights.Get(Index) - dividerHeight
		p.top = NewTop
	Next
	sv.ContentHeight = sv.ContentHeight - heights.Get(Index) - dividerHeight
	items.RemoveAt(Index)
	panels.RemoveAt(Index)
	heights.RemoveAt(Index)
	removePanel.RemoveViewFromParent
End Sub


'Adds a text item. The item height will be adjusted based on the text.
Public Sub AddTextItem(Text As String, Value As Object)
	InsertAtTextItem(items.Size, Text, Value)
	
End Sub

'Inserts a text item at the specified index.
Public Sub InsertAtTextItem(Index As Int, Text As String, Value As Object)
	Dim pnl As Panel
	pnl.Initialize("")
	Dim lbl As Label
	lbl.Initialize("")
	lbl.TextAlignment = lbl.ALIGNMENT_LEFT
	pnl.AddView(lbl, 5dip, 2dip, sv.Width - 5dip, 20dip)
	lbl.Text = Text
	lbl.Multiline = True
	lbl.Font = DefaultTextFont
	lbl.TextColor = DefaultTextColor
	pnl.Color = DefaultTextBackgroundColor
	lbl.SizeToFit
	lbl.Height = Max(50dip, lbl.Height)
	InsertAt(Index, pnl, lbl.Height + 2dip, Value)
End Sub

'Changes the height of an existing item.
Public Sub ResizeItem(Index As Int, ItemHeight As Int)
	Dim p As Panel = GetPanel(Index)
	Dim value As Object = items.Get(Index)
	Dim parent As Panel = p.Parent
	p.Color = parent.Color
	p.RemoveViewFromParent
	ReplaceAt(Index, p, ItemHeight, value)
End Sub

'Replaces the item at the specified index with a new item.
Public Sub ReplaceAt(Index As Int, pnl As Panel, ItemHeight As Int, Value As Object)
	Dim removePanel As Panel = panels.Get(Index)
	Dim height As Int = heights.Get(Index)
	items.RemoveAt(Index)
	panels.RemoveAt(Index)
	heights.RemoveAt(Index)
	removePanel.RemoveViewFromParent
	InsertAtImpl(Index, pnl, ItemHeight, Value, height)
End Sub

'Adds a custom item at the specified index.
Public Sub InsertAt(Index As Int, pnl As Panel, ItemHeight As Int, Value As Object)
	InsertAtImpl(Index, pnl, ItemHeight, Value, 0)
End Sub
Private Sub InsertAtImpl(Index As Int, Pnl As Panel, ItemHeight As Int, Value As Object, InitialHeight As Int)
	'create another panel to handle the click event
	Dim p As Panel
	p.Initialize("panel")
	p.Color = Pnl.Color
	Pnl.Color = Colors.Transparent
	p.AddView(Pnl, 0, 0, sv.Width, ItemHeight)
	p.Tag = Index
	Dim IncludeDividierHeight As Int
	If InitialHeight = 0 Then IncludeDividierHeight = dividerHeight Else IncludeDividierHeight = 0
	If Index = items.Size And InitialHeight = 0 Then
		items.Add(Value)
		panels.Add(p)
		heights.Add(ItemHeight)
		Dim top As Int
		If Index = 0 Then top = dividerHeight Else top = sv.ContentHeight
		sv.Panel.AddView(p, 0, top, sv.Width, ItemHeight)
	Else
		Dim top As Int
		If Index = 0 Then
			top = dividerHeight
		Else
			Dim previousPanel As Panel = panels.Get(Index - 1)
			top = previousPanel.top + heights.Get(Index - 1) + dividerHeight
		End If
		Dim p2 As Panel
		For i = Index To panels.Size - 1
			p2 = panels.Get(i)
			Dim NewTop As Int = p2.top + ItemHeight - InitialHeight + IncludeDividierHeight
			If  Min(NewTop, p2.Top) - sv.ScrollOffsetY < sv.Height Then
				p2.SetLayoutAnimated(AnimationDuration, 1, 0, NewTop, p2.Width, heights.Get(i))
			Else
				p2.top = NewTop
			End If
			p2.Tag = i + 1
		Next
		items.InsertAt(Index, Value)
		panels.InsertAt(Index, p)
		heights.InsertAt(Index, ItemHeight)
		sv.Panel.AddView(p, 0, top, sv.Width, InitialHeight)
		p.SetLayoutAnimated(AnimationDuration, 1, 0, top, p.Width, ItemHeight)
	End If
	sv.ContentHeight = sv.ContentHeight + ItemHeight - InitialHeight + IncludeDividierHeight
	If items.Size = 1 Then sv.ContentHeight = sv.ContentHeight + IncludeDividierHeight
End Sub

'Adds a custom item.
Public Sub Add(Pnl As Panel, ItemHeight As Int, Value As Object)
	InsertAt(items.Size, Pnl, ItemHeight, Value)
End Sub

'Scrolls the list to the specified item.
Public Sub JumpToItem(Index As Int)
	SetOffset(FindItemTop(Index))
End Sub



Private Sub FindItemTop(Index As Int) As Int
	Dim top As Int
	For i = 0 To Min(Index - 1, items.Size - 1)
		top = top + heights.Get(i) + dividerHeight
	Next
	Return top
End Sub

'Smoothly scrolls the list to the specified item.
Public Sub ScrollToItem(Index As Int)
	sv.ScrollTo(0, FindItemTop(Index), True)
End Sub

'Gets the index of the first visible item.
Public Sub getFirstVisibleIndex As Int
	Dim bottom As Int
	For i = 0 To items.Size - 1
		bottom = bottom + heights.Get(i) + dividerHeight
		If bottom > sv.ScrollOffsetY Then Return i		
	Next
	Return items.Size - 1
End Sub

'Gets the index of the last visible item.
Public Sub getLastVisibleIndex As Int
	Dim first As Int = getFirstVisibleIndex
	Dim bottom As Int
	For i = 0 To items.Size - 1
		bottom = bottom + heights.Get(i) + dividerHeight
		If i >= first And bottom >= sv.ScrollOffsetY  + sv.Height Then Return Max(i - 1, first)
	Next
	Return items.Size - 1
End Sub

Private Sub Panel_Click
	Dim p As Panel = Sender
	'Edward : disable the change color
'	p.GetView(0).Color = HighlightColor
'	p.GetView(0).SetColorAnimated(700, Colors.Transparent)
	CallSub3(CallBack, EventName & "_ItemClick", p.Tag, items.Get(p.Tag))
End Sub

Private Sub Panel_LongClick
   Dim p As Panel = Sender
	'Edward : disable the change color
'   p.GetView(0).Color = HighlightColor
'   p.GetView(0).SetColorAnimated(700, Colors.Transparent)
   CallSub3(CallBack, EventName & "_ItemLongClick", p.Tag, items.Get(p.Tag))
End Sub

Private Sub SetOffset(y As Int)
	sv.ScrollOffsetY = Max(0, Min(y, sv.ContentHeight - sv.Height))
End Sub

'Returns the index of the item that holds the given view.
Public Sub GetItemFromView(v As View) As Int
	Dim parent = v As Object, current As View
	Do While (parent Is Panel) = False Or sv.Panel <> parent
		current = parent
		parent = current.Parent
	Loop
	v = current
	Return v.Tag
End Sub

Private Sub sv_ScrollChanged (OffsetX As Int, OffsetY As Int)
	If OffsetY + sv.Height >= sv.ContentHeight - 5dip And DateTime.Now > LastReachEndEvent + 100 Then
		If SubExists(CallBack, EventName & "_ReachEnd", 0) Then
			LastReachEndEvent = DateTime.Now
			CallSubDelayed(CallBack, EventName & "_ReachEnd")
		Else
			LastReachEndEvent = DateTime.Now + 1000 * DateTime.TicksPerDay 'disable
		End If
	End If
End Sub